Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3582)
@@ -10913,745 +9936,356 @@
     
        CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
+          vari = TRIM( variable )
           IF ( av == 0 )  THEN
-             IF ( TRIM( variable ) == 'g_H2SO4')  icc = 1
-             IF ( TRIM( variable ) == 'g_HNO3')   icc = 2
-             IF ( TRIM( variable ) == 'g_NH3')    icc = 3
-             IF ( TRIM( variable ) == 'g_OCNV')   icc = 4
-             IF ( TRIM( variable ) == 'g_OCSV')   icc = 5
-             
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      local_pf(i,j,k) = salsa_gas(icc)%conc(mask_k(mid,k),     &
-                                                    mask_j(mid,j),mask_i(mid,i))
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( vari == 'g_H2SO4')  to_be_resorted => salsa_gas(1)%conc
+             IF ( vari == 'g_HNO3')   to_be_resorted => salsa_gas(2)%conc
+             IF ( vari == 'g_NH3')    to_be_resorted => salsa_gas(3)%conc
+             IF ( vari == 'g_OCNV')   to_be_resorted => salsa_gas(4)%conc
+             IF ( vari == 'g_OCSV')   to_be_resorted => salsa_gas(5)%conc 
           ELSE
-             IF ( TRIM( variable(3:) ) == 'H2SO4' ) to_be_resorted => g_H2SO4_av
-             IF ( TRIM( variable(3:) ) == 'HNO3' )  to_be_resorted => g_HNO3_av   
-             IF ( TRIM( variable(3:) ) == 'NH3' )   to_be_resorted => g_NH3_av   
-             IF ( TRIM( variable(3:) ) == 'OCNV' )  to_be_resorted => g_OCNV_av   
-             IF ( TRIM( variable(3:) ) == 'OCSV' )  to_be_resorted => g_OCSV_av 
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      local_pf(i,j,k) = to_be_resorted(mask_k(mid,k),          &
-                                                    mask_j(mid,j),mask_i(mid,i))
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( vari == 'g_H2SO4') to_be_resorted => g_H2SO4_av
+             IF ( vari == 'g_HNO3')  to_be_resorted => g_HNO3_av   
+             IF ( vari == 'g_NH3')   to_be_resorted => g_NH3_av   
+             IF ( vari == 'g_OCNV')  to_be_resorted => g_OCNV_av   
+             IF ( vari == 'g_OCSV')  to_be_resorted => g_OCSV_av
           ENDIF
-       
+          
        CASE ( 'LDSA' )
           IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
+                      DO  b = 1, nbins
 !                      
 !--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * Ra_dry(mask_k(mid,k),            &
-                                       mask_j(mid,j),mask_i(mid,i),n) * 2.0_wp
+                         mean_d = 1.0E+6_wp * Ra_dry(k,j,i,b) * 2.0_wp
 !                               
-!--                      Deposition factor: alveolar (use Ra_dry for the size??)                                
+!--                      Deposition factor: alveolar                                
                          df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp *     &
-                                ( LOG( mean_d ) + 2.84_wp )**2.0_wp )          &
-                                  + 19.11_wp * EXP( -0.482_wp *                &
-                                  ( LOG( mean_d ) - 1.362_wp )**2.0_wp ) )
+                              ( LOG( mean_d ) + 2.84_wp )**2.0_wp ) + 19.11_wp &
+                              * EXP( -0.482_wp * ( LOG( mean_d ) - 1.362_wp    &
+                                )**2.0_wp ) )
 !                                    
 !--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(n)%conc(mask_k(mid,k),&
-                                                    mask_j(mid,j),mask_i(mid,i))
+                         nc = 1.0E-6_wp * aerosol_number(b)%conc(k,j,i)
 !                         
 !--                      Lung-deposited surface area LDSA (units mum2/cm3)
                          temp_bin = temp_bin + pi * mean_d**2.0_wp * df * nc 
                       ENDDO
-                      local_pf(i,j,k) = temp_bin
+                      tend(k,j,i) = temp_bin
                    ENDDO
                 ENDDO
              ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = LDSA_av(mask_k(mid,k),                &
-                                                 mask_j(mid,j),mask_i(mid,i))
+             IF ( .NOT. mask_surface(mid) )  THEN   
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
+                                                 mask_i(mid,i) )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ELSE 
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
+                                                      nzt+1 ),                 &
+                                                 mask_j(mid,j), mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             resorted = .TRUE.
+          ELSE
+             to_be_resorted => LDSA_av
           ENDIF
-       
+          
+       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6',   &
+              'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) b = 1
+          IF ( TRIM( variable(6:) ) == '2' ) b = 2
+          IF ( TRIM( variable(6:) ) == '3' ) b = 3
+          IF ( TRIM( variable(6:) ) == '4' ) b = 4
+          IF ( TRIM( variable(6:) ) == '5' ) b = 5
+          IF ( TRIM( variable(6:) ) == '6' ) b = 6
+          IF ( TRIM( variable(6:) ) == '7' ) b = 7
+          IF ( TRIM( variable(6:) ) == '8' ) b = 8
+          IF ( TRIM( variable(6:) ) == '9' ) b = 9
+          IF ( TRIM( variable(6:) ) == '10' ) b = 10
+          IF ( TRIM( variable(6:) ) == '11' ) b = 11
+          IF ( TRIM( variable(6:) ) == '12' ) b = 12
+          
+          IF ( av == 0 )  THEN
+             IF ( .NOT. mask_surface(mid) )  THEN   
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = aerosol_number(b)%conc( mask_k(mid,k),&
+                                                                   mask_j(mid,j),&
+                                                                   mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE 
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = aerosol_number(b)%conc(             &
+                                           MIN( topo_top_ind+mask_k(mid,k),    &
+                                                nzt+1 ),                 &
+                                           mask_j(mid,j), mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             resorted = .TRUE.
+          ELSE
+             to_be_resorted => Nbins_av(:,:,:,b)
+          ENDIF
+          
        CASE ( 'Ntot' )
           IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
-                         temp_bin = temp_bin + aerosol_number(n)%conc(         &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
+                      DO  b = 1, nbins
+                         temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
                       ENDDO
-                      local_pf(i,j,k) = temp_bin
+                      tend(k,j,i) = temp_bin
                    ENDDO
                 ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Ntot_av(mask_k(mid,k),                &
-                                                 mask_j(mid,j),mask_i(mid,i))
+             ENDDO 
+             IF ( .NOT. mask_surface(mid) )  THEN   
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
+                                                 mask_i(mid,i) )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ELSE 
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
+                                                      nzt+1 ),                 &
+                                                 mask_j(mid,j), mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             resorted = .TRUE.
+          ELSE
+             to_be_resorted => Ntot_av
+          ENDIF
+          
+       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',   'm_bin5',  'm_bin6',   &
+              'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) b = 1
+          IF ( TRIM( variable(6:) ) == '2' ) b = 2
+          IF ( TRIM( variable(6:) ) == '3' ) b = 3
+          IF ( TRIM( variable(6:) ) == '4' ) b = 4
+          IF ( TRIM( variable(6:) ) == '5' ) b = 5
+          IF ( TRIM( variable(6:) ) == '6' ) b = 6
+          IF ( TRIM( variable(6:) ) == '7' ) b = 7
+          IF ( TRIM( variable(6:) ) == '8' ) b = 8
+          IF ( TRIM( variable(6:) ) == '9' ) b = 9
+          IF ( TRIM( variable(6:) ) == '10' ) b = 10
+          IF ( TRIM( variable(6:) ) == '11' ) b = 11
+          IF ( TRIM( variable(6:) ) == '12' ) b = 12
+          
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nz_do3d
+                      temp_bin = 0.0_wp
+                      DO  c = b, ncc_tot*nbins, nbins
+                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      ENDDO
+                      tend(k,j,i) = temp_bin
+                   ENDDO
+                ENDDO
+             ENDDO   
+             IF ( .NOT. mask_surface(mid) )  THEN   
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
+                                                 mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE 
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
+                                                      nzt+1 ),                 &
+                                                 mask_j(mid,j), mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             resorted = .TRUE.
+          ELSE
+             to_be_resorted => mbins_av(:,:,:,b)
           ENDIF
        
        CASE ( 'PM2.5' )
           IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(mask_k(mid,k),mask_j(mid,j),     &
-                              mask_i(mid,i),n) <= 2.5E-6_wp )  THEN
-                            DO  c = n, nbins*ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(     &
-                                     mask_k(mid,k), mask_j(mid,j),mask_i(mid,i))
+                      DO  b = 1, nbins
+                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 2.5E-6_wp )  THEN
+                            DO  c = b, nbins * ncc, nbins
+                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
                             ENDDO
                          ENDIF
                       ENDDO
-                      local_pf(i,j,k) = temp_bin
+                      tend(k,j,i) = temp_bin
                    ENDDO
                 ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = PM25_av(mask_k(mid,k),                &
-                                                 mask_j(mid,j),mask_i(mid,i))
+             ENDDO 
+             IF ( .NOT. mask_surface(mid) )  THEN   
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
+                                                 mask_i(mid,i) )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ELSE 
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
+                                                      nzt+1 ),                 &
+                                                 mask_j(mid,j), mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             resorted = .TRUE.
+          ELSE
+             to_be_resorted => PM25_av
           ENDIF
-       
+          
        CASE ( 'PM10' )
           IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(mask_k(mid,k),mask_j(mid,j),     &
-                              mask_i(mid,i),n) <= 10.0E-6_wp )  THEN
-                            DO  c = n, nbins*ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(     &
-                                      mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
+                      DO  b = 1, nbins
+                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 10.0E-6_wp )  THEN
+                            DO  c = b, nbins * ncc, nbins
+                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
                             ENDDO
                          ENDIF
                       ENDDO
-                      local_pf(i,j,k) = temp_bin
+                      tend(k,j,i) = temp_bin
                    ENDDO
                 ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = PM10_av(mask_k(mid,k),                &
-                                                 mask_j(mid,j),mask_i(mid,i))
+             ENDDO 
+             IF ( .NOT. mask_surface(mid) )  THEN   
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
+                                                 mask_i(mid,i) )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin1' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(1)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i))
+             ELSE 
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
+                                                      nzt+1 ),                 &
+                                                 mask_j(mid,j), mask_i(mid,i) )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
+             resorted = .TRUE.
           ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),1)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin2' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(2)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),2)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin3' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(3)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i))
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),3)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin4' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(4)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i))
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),4)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin5' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(5)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i))
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),5)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin6' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(6)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),6)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin7' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(7)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),7)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin8' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(8)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),8)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin9' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(9)%conc(mask_k(mid,k),  &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),9)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin10' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(10)%conc(mask_k(mid,k), &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                 mask_j(mid,j),mask_i(mid,i),10)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin11' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(11)%conc(mask_k(mid,k), &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                 mask_j(mid,j),mask_i(mid,i),11)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin12' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)                      
-                      local_pf(i,j,k) = aerosol_number(12)%conc(mask_k(mid,k), &
-                                                 mask_j(mid,j),mask_i(mid,i)) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = Nbins_av(mask_k(mid,k),               &
-                                                 mask_j(mid,j),mask_i(mid,i),12)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin1' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 1, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),1)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin2' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 2, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),2)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin3' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 3, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),3)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin4' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 4, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),4)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin5' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 5, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),5)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin6' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 6, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),6)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin7' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 7, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),7)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin8' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 8, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),8)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin9' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 9, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                  mask_j(mid,j),mask_i(mid,i),9)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin10' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 10, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                 mask_j(mid,j),mask_i(mid,i),10)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin11' )
-         IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 11, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                 mask_j(mid,j),mask_i(mid,i),11)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin12' )
-          IF ( av == 0 )  THEN
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                      temp_bin = 0.0_wp
-                      DO  c = 12, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(           &
-                                    mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
-                      ENDDO
-                      local_pf(i,j,k) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = 1, mask_size_l(mid,1)
-                DO  j = 1, mask_size_l(mid,2)
-                   DO  k = 1, mask_size_l(mid,3)
-                       local_pf(i,j,k) = mbins_av(mask_k(mid,k),               &
-                                                 mask_j(mid,j),mask_i(mid,i),12)
-                   ENDDO
-                ENDDO
-             ENDDO
+             to_be_resorted => PM10_av
           ENDIF
           
        CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
-          IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-             icc = get_index( prtcl, TRIM( variable(3:) ) )
-             IF ( av == 0 )  THEN
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
+          IF ( av == 0 )  THEN
+             IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
+                icc = get_index( prtcl, TRIM( variable(3:) ) )
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
                          temp_bin = 0.0_wp
                          DO  c = ( icc-1 )*nbins+1, icc*nbins 
-                            temp_bin = temp_bin + aerosol_mass(c)%conc(        &
-                                      mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
+                            temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
                          ENDDO
-                         local_pf(i,j,k) = temp_bin
+                         tend(k,j,i) = temp_bin
                       ENDDO
                    ENDDO
                 ENDDO
              ELSE
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_BC_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_DU_av   
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_NH_av   
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_NO_av   
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_OC_av   
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_SO4_av   
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_SS_av 
+                tend = 0.0_wp
+             ENDIF
+             IF ( .NOT. mask_surface(mid) )  THEN   
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)                   
-                         local_pf(i,j,k) = to_be_resorted(mask_k(mid,k),       &
-                                                    mask_j(mid,j),mask_i(mid,i))
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), &
+                                                 mask_i(mid,i) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE      
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
+                                                                  mask_i(mid,i),&
+                                                                  grid )
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
+                                                      nzt+1 ),&
+                                                 mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
                 ENDDO
              ENDIF
+             resorted = .TRUE.
+          ELSE
+             IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_BC_av
+             IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_DU_av   
+             IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_NH_av   
+             IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_NO_av   
+             IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_OC_av   
+             IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_SO4_av   
+             IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_SS_av
           ENDIF
        
